function main() {
    // 現在のページのURLを取得
    const currentURL = window.location.href;

    // https://x.com/search?q={query}&src=typed_query&f=live
    const url = new URL(currentURL);

    // console.log("main!!")

    // ここでミュートワードを作る
    let tail = ""
    chrome.storage.sync.get(['tailDict'], function(result) {
        tailDict = result.tailDict
        for (let t of Object.keys(tailDict)) {
            if (tailDict[t] == "Active") {
                tail += " " + t
            }
        }

        // console.log("tail",tail)

        // URLSearchParamsオブジェクトを使用してクエリパラメータを取得・変更
        const params = new URLSearchParams(url.search);

        // console.log(params.get("q"))
        // console.log(params.get("q").includes(tail))
        if (!params.get("q").includes(tail)) {
            params.set('q', params.get("q") + tail); // パラメータ 'q' の値を 'xxx' に変更
            // 新しいURLを作成
            const newUrlString = `${url.origin}${url.pathname}?${params.toString()}`;
            window.location.href = newUrlString;
        }
    });
}

// MutationObserverを使用してURLの変更を監視
const observer = new MutationObserver((mutations) => {
    mutations.forEach((mutation) => {
        if (mutation.type === 'childList' || mutation.type === 'attributes') {
            // console.log('URLが変更されました:', window.location.href);
            main()
        }
    });
});

// タイトル要素を監視
const targetNode = document.querySelector('body');
if (targetNode) {
    observer.observe(targetNode, { childList: true, subtree: true });
}

// ページロード時に現在のURLを表示
window.addEventListener('load', function() {
    main()
});

// ページ遷移時に現在のURLを更新
window.addEventListener('popstate', function() {
    main()
});