// options.js

document.addEventListener('DOMContentLoaded', function() {
    // SaveボタンのクリックイベントにsaveOptions関数を追加します
    document.getElementById('saveButton').addEventListener('click', saveOptions);
});
  
function saveOptions() {
    var tail = document.getElementById('tailInput').value;
    tail = tail.split(" ")

    // 既に設定してある単語を表示
    // tailDict = {"Active":[],"Inactive":[]}
    chrome.storage.sync.get(['tailDict'], function(result) {
        tailDict = result.tailDict

        for (let i=0;i<tail.length;i++) {
            tailDict[tail[i]] = "Active"
            // console.log(tail[i])
        }
        chrome.storage.sync.set({tailDict: tailDict}, function() {
            // console.log('Options saved');
            showSavedMessage()
        });

        let wordList = document.getElementById("wordList")
        wordList.innerHTML = ""
        for (let tail of Object.keys(tailDict)) {
            let tailDiv = document.createElement("div")
            let tailText = document.createElement("label")
            tailText.classList.add("tailText")
            tailText.style.fontSize = "24px"
            tailText.innerText = tail
            tailText.htmlFor = "tailCheck-" + tail

            let tailCheck = document.createElement("input")
            tailCheck.type = "checkbox"
            tailCheck.id = "tailCheck-" + tail
            if (tailDict[tail] == "Active") {
                tailCheck.checked = true
            }
            
            tailCheck.addEventListener("change", () => {
                if (tailCheck.checked) {
                    tailDict[tail] = "Active"
                }
                else {
                    tailDict[tail] = "Inactive"
                }
                // console.log(tail)
                chrome.storage.sync.set({tailDict: tailDict}, function() {
                    // console.log('Options saved');
                });
            }) 

            let tailRemove = document.createElement("button")
            tailRemove.textContent = "削除する"
            tailRemove.style.marginLeft = "10px"
            tailRemove.addEventListener("click", () => {
                delete tailDict[tail]
                // console.log(tail)
                chrome.storage.sync.set({tailDict: tailDict}, function() {
                    // console.log('Options saved');
                });

                tailDiv.style.display = "none"
            }) 

            tailDiv.appendChild(tailCheck)
            tailDiv.appendChild(tailText)
            tailDiv.appendChild(tailRemove)
            wordList.appendChild(tailDiv)
        }
    });
}

function showSavedMessage() {
    var toastMessage = document.getElementById('toastMessage');
    toastMessage.classList.remove('hidden');
    toastMessage.classList.add('show');

    // 3秒後にメッセージを非表示にする
    setTimeout(function() {
        toastMessage.classList.remove('show');
        toastMessage.classList.add('hidden');
    }, 3000);
}

function init() {
    chrome.storage.sync.get(['tailDict'], function(result) {
        tailDict = result.tailDict
        let wordList = document.getElementById("wordList")
        wordList.innerHTML = ""
        for (let tail of Object.keys(tailDict)) {
            let tailDiv = document.createElement("div")
            let tailText = document.createElement("label")
            tailText.classList.add("tailText")
            tailText.style.fontSize = "16px"
            tailText.innerText = tail
            tailText.htmlFor = "tailCheck-" + tail
    
            let tailCheck = document.createElement("input")
            tailCheck.type = "checkbox"
            tailCheck.id = "tailCheck-" + tail
            if (tailDict[tail] == "Active") {
                tailCheck.checked = true
            }
            
            tailCheck.addEventListener("change", () => {
                if (tailCheck.checked) {
                    tailDict[tail] = "Active"
                }
                else {
                    tailDict[tail] = "Inactive"
                }
                // console.log(tail)
                chrome.storage.sync.set({tailDict: tailDict}, function() {
                    // console.log('Options saved');
                });
            }) 
    
            let tailRemove = document.createElement("button")
            tailRemove.textContent = "削除する"
            tailRemove.style.marginLeft = "10px"
            tailRemove.addEventListener("click", () => {
                delete tailDict[tail]
                // console.log(tail)
                chrome.storage.sync.set({tailDict: tailDict}, function() {
                    // console.log('Options saved');
                });
    
                tailDiv.style.display = "none"
            }) 
    
            tailDiv.appendChild(tailCheck)
            tailDiv.appendChild(tailText)
            tailDiv.appendChild(tailRemove)
            wordList.appendChild(tailDiv)
        }
    })
}

  init()